# Flake-o-rama

Nix Flake dotfiles used on my server.

## Todo

* Make it so our secrets consist upon reboot (currently just our wifi password, have to set every reboot) (maybe with [Agenix](https://github.com/ryantm/agenix) + [Age](https://github.com/FiloSottile/age)?)
* Migrate our openresty/nginx modules and our gitea themes to actual packages
* Maybe make it so that SSH auth works in gitea (open some ports) (it's really annoying typing in password all the time) 

## Development

_Commands here will assume you are currently in the directory of the dotfiles._

- To build the system:
	```sh
	sudo nixos-rebuild switch --flake ".#server"
	```
- To update the system:
	```sh
	sudo nixos-rebuild switch --upgrade --flake ".#server"
	```
- To test the system:
	```sh
	nix flake check
	```

## Permissions

_Commands here will assume you are currently in the directory of the dotfiles._

File permissions should be done through the following commands:
```sh
sudo chmod 775 -R .
sudo chown -R reidlab:dotfiles .
```
